/* 
          DK16.
    4-  (+, -, Set, Cancel).
   11.00.
  File DK16Set4.c
*/

//--------------------------------
//    unsigned int
unsigned char SetUInt ( unsigned int *Num, unsigned char Quant, unsigned char Decs, unsigned char Pos, 
  unsigned int Min, unsigned int Max )
{
  unsigned int S;
  unsigned char Key;

  S = *Num;
  if ( S > Max ) S = Max;
  if ( S < Min ) S = Min;
  while ( DK16_ReadKey () )
    {
      CLRWDT ();
#ifdef CheckI2CErrors
      if ( ErrorFl ) return ( 0 );
#endif
    }
  SecSet = 0;
  Forever
    {
      if ( SecSet > 10 ) 
        {
          return ( 0 );
        }
      if ( Decs ) ClearPos ( Quant + 1, Pos );
      else ClearPos ( Quant, Pos );
#ifdef CheckI2CErrors
      if ( ErrorFl ) return ( 0 );
#endif
      Delay ( 4 );         
      ShowUInt ( S, Quant, Decs, Pos );
#ifdef CheckI2CErrors
      if ( ErrorFl ) return ( 0 );
#endif
      Delay ( 10 );
      Key = DK16_ReadKey ();
#ifdef CheckI2CErrors
      if ( ErrorFl ) return ( 0 );
#endif
      if ( ! Key ) continue;                
      SecSet = 0; 
      if ( Key == KeyCancel ) return ( 0 );
      if ( Key == KeySet ) 
        {
          *Num = S;   
          return ( 1 );
        }
      if ( Key == KeyPlus ) 
        {
          if ( S < Max ) S++;
        }
      if ( Key == KeyMinus ) 
        {
          if ( S > Min ) S--;
        }
    }
  return ( 1 );
} // SetUInt

