/* 
          DK16.
    12  (, , ).
   11.00.
  File DK16Se12.c
*/

//-----------------------------------------
//     
unsigned char KeyToDig ( unsigned char K )
{
  switch ( K )
    {
      case Key1 : return ( 1 );
      case Key2 : return ( 2 );
      case Key3 : return ( 3 );
      case Key4 : return ( 4 );
      case Key5 : return ( 5 );
      case Key6 : return ( 6 );
      case Key7 : return ( 7 );
      case Key8 : return ( 8 );
      case Key9 : return ( 9 );
    }
  return ( 0 );  
} // KeyToDig

//--------------------------------
//    unsigned int
unsigned char SetUInt ( unsigned int *Par, unsigned char Quant, unsigned char Decs, unsigned char Pos, 
  unsigned int Min, unsigned int Max )
{
  unsigned int N;
  unsigned long M;
  unsigned char K;

  N = *Par;
  if ( N > Max ) N = Max;
  if ( N < Min ) N = Min;
  while ( DK16_ReadKey () )
    {
      CLRWDT ();
#ifdef CheckI2CErrors
      if ( ErrorFl ) return ( 0 );
#endif
    }
  SecSet = 0;
  Forever
    {
      if ( SecSet > 20 ) return ( 0 );

      if ( Decs ) ClearPos ( Quant + 1, Pos );
      else ClearPos ( Quant, Pos );
#ifdef CheckI2CErrors
      if ( ErrorFl ) return ( 0 );
#endif
      Delay ( 4 );         
      ShowUInt ( ( unsigned int ) ( N ), Quant, Decs, Pos );
#ifdef CheckI2CErrors
      if ( ErrorFl ) return ( 0 );
#endif
      Delay ( 10 );         
      K = DK16_ReadKey ();
#ifdef CheckI2CErrors
      if ( ErrorFl ) return ( 0 );
#endif
      if ( ! K ) continue;                
      SecSet = 0; 
      switch ( K ) 
        {
          case KeyK : 
            if ( N < Min ) N = Min;
            *Par = N;
            return ( 1 );
          case KeyC : 
            N = 0;
            SecSet = 0;
            break;
          default :  
            M = N * 10 + KeyToDig ( K );
            if ( M <= Max ) N = M;
            SecSet = 0;
            break;
        }
    }
  return ( 0 );
} // SetUInt

