/* 
           DK16.
   11.00.
  File DK16Show.c
*/

//-----------------------------------------
//  
void ShowMessage ( unsigned char Pos, TMessage M )
{
  unsigned char i;
  
  DK16_Goto ( Pos );
#ifdef CheckI2CErrors
  if ( ErrorFl ) return;
#endif
  for ( i = 0; i < M.Len; i++ )
    {
      DK16_PutCh ( WinToDisp ( M.Mes [ i ] ) ) ;
#ifdef CheckI2CErrors
      if ( ErrorFl ) return;
#endif
      CLRWDT ();
    }
} // ShowMessage

//--------------------------------
//       
void ClearPos ( unsigned char Quant, unsigned char Pos )
{
  unsigned char i;

  DK16_Goto ( Pos );
  for ( i = 0; i < Quant; i++ )
    {
      DK16_PutCh ( ' ' );
#ifdef CheckI2CErrors
      if ( ErrorFl ) return;
#endif
    }
}  // ClearPos

//--------------------------------
//      unsigned int
void ShowUInt ( unsigned int C, unsigned char Quant, unsigned char Decs, unsigned char Pos )
{
  unsigned char i, Fl = 0, CC;
  unsigned int j;
  
  CLRWDT ();
  DK16_Goto ( Pos );
#ifdef CheckI2CErrors
  if ( ErrorFl ) return;
#endif
  j = 1;
  for ( i = 1; i < Quant; i++ ) j *= 10;
  for ( i = 0; i < Quant; i++ )
    {
      if ( i == Quant - Decs - 1 ) Fl = 1;
      if ( i == Quant - Decs ) DK16_PutCh ( '.' );
#ifdef CheckI2CErrors
      if ( ErrorFl ) return;
#endif
      CC = ( ( C / j ) % 10 );
      if ( ( ! CC ) && ( !Fl ) )
        { 
          DK16_PutCh ( ' ' );
#ifdef CheckI2CErrors
      if ( ErrorFl ) return;
#endif
        }
      else
        {
          DK16_PutCh ( CC + 0x30 );
#ifdef CheckI2CErrors
      if ( ErrorFl ) return;
#endif
          Fl = 1;
        }
        
      j /= 10;
    }
}  // ShowUInt


